* This will replicate most of the analyses from
* Williams, Richard.  2009. "Using Heterogeneous Choice Models To Compare Logit and Probit
* Coefficients Across Groups" Sociological Methods & Research 37(4): 531-559.A pre-publication
* version is available at http://www.nd.edu/~rwilliam/oglm/RW_Hetero_Choice.pdf.
* The code for the simulations is in a separate file.


version 9.2
* Step 1. Unconstrained models, all coefficients can differ by gender. 
use "http://www.indiana.edu/~jslsoc/stata/spex_data/tenure01.dta", clear 
* Allison limited the sample to the first 10 years untenured 
keep if pdasample 
* Males Only 
oglm tenure year yearsq select articles prestige if male, store(step1male) 
* Females Only 
oglm tenure year yearsq select articles prestige if female, store(step1fem) 
* Equivalent pooled model, using interactions. 
oglm tenure year yearsq select articles prestige f_year f_yearsq f_select f_articles f_prestige female, store(step1) 
* Step 2. Pooled model; only the intercepts differ by gender. 
* Allison refers to this model but does not present it in the paper. 
oglm tenure year yearsq select articles prestige female, store(step2) 
* Step 3. Residual variances allowed to differ by gender. 
* Allisons model is actually a special case of a heterogeneous 
* choice model, and it is easy to compute Allisons delta using oglm. 
* Compare these results with the first half of Allisons Table 2. 
oglm tenure female year yearsq select articles prestige , het(female) store(step3) 
* Compute delta 
display (1 - exp(.3022305))/ exp(.3022305) 
* Step 4A. Test that the Alphas are = but residual variances differ. 
lrtest step2 step3, stats 
* Step 4B. Test whether any Alphas differ across groups given that 
* residual variances differ. 
lrtest step1 step3, stats 
* Step 4C. Test whether the effect of articles differs across groups. 
* First have to estimate the model with the interaction term added. 
* Compare this with the second half of Allisons Table 2. 
oglm tenure female year yearsq select articles prestige f_articles, het(female) store(step4c) 
* Compute delta 
display (1 - exp(.1774193))/ exp(.1774193) 
* Now do the formal test of the female*articles interaction term. 
lrtest step3 step4c, stats 
use "http://www.indiana.edu/~jslsoc/stata/spex_data/ordwarm2.dta", clear 
* Compute interaction terms 
gen male89 = male*yr89 
gen malewhit = male*white 
gen maleage = male*age 
gen maleed = male*ed 
gen maleprst = male*prst 
* Model 1, Table 5 
oglm warm yr89 male white age ed prst 
mfx2, stub(m1) nolog 
* Model 2, Table 5 
oglm warm yr89 male white age ed prst male89 malewhit maleage maleed maleprst 
mfx2, stub(m2) nolog 
* Model 3, Table 5 nolog 
oglm warm yr89 male white age ed prst, het(yr89 male) 
mfx2, stub(m3) nolog 
* Alternative coding for Model 3, Table 5 
* using stepwise regression for the variance equation 
sw, pe(.05) lr: oglm warm yr89 male white age ed prst, eq2( yr89 male white age ed prst) flip 
* Model 4, Table 5 
oglm warm yr89 male white age ed prst male89 malewhit maleage maleed maleprst, het(yr89 male) 
mfx2, stub(m4) nolog 